#include "lib.h"
#include "screens.h"

/*#define MAKE */

unsigned char *memc=(unsigned char *)0;

#ifdef MAKE
void
makescreens()
{
     lores0();
     cls();
     paper(0);
     ink(7);
     printf("%c%c%c",29,8,8);

     printf("\033R       \033P \033T                 \033P\033I\033T         ");
     printf("\033R...... \033P \033T !\"#$%%&'()*+,-./ \033P\033I\033T !\"#$%%^' ");
     printf("\033R...... \033P \033T0123456789:;<=>? \033P\033I\033T()*+,-./ ");
     printf("\033R...... \033P \033T@ABCDEFGHIJKLMNO \033P\033I\033T01234567 ");
     printf("\033R...... \033P \033TPQRSTUVWXYZ[\\]^_ \033P\033I\033T89:;<=>? ");
     printf("\033R...... \033P \033T`abcdefghijklmno \033P\033I\033T@ABCDEFG ");
     printf("\033R...... \033P \033Tpqrstuvwxyz{|}~  \033P\033I\033THIJKLMNO ");
     printf("\033R...... \033P \033T                 \033P\033I\033TPQRSTUVW ");
     printf("\033R...... \033P \033T                 \033P\033I\033TXYZ[\\]^_ ");
     printf("\033R       \033P \033T                 \033P\033I\033T         \n");
     memc[48000+7*40+26=0x7f];
     printf("Arrows: move cursor.  ESC: change panel.");
     printf("Space:  toggle pixel. RET: select char.\n\n");
     printf("Press\033C?\033Gto get help.\n\n");
     printf("Inverse: \033CI\033G    Roll X: \033CH\033G    Next:  \033C>");
     printf("Clear:   \033CC\033G    Roll Y: \033CV\033G    Prev:  \033C<");
     printf("Revert:  \033CR\033G    Cut:    \033CU\033G    Save:  \033CS");
     printf("Mirror X:\033CX\033G    Paste:  \033CP\033G    Load:  \033CL");
     printf("Mirror Y:\033CY\033G    Swap:   \033CW\033G    About: \033CA");

     for(;!key(););

     lores0();
     cls();
     paper(0);
     ink(7);

           /*1234567890123456789012345678901234567890*/
     printf("Use the\033Carrow keys\033Gto move the cursor. ");
     printf("                                         ");
     printf("Grid panel:\033CSpace\033Btoggles pixel. \033CEscape");
     printf("\033B moves to charset panels.\n");
     printf("\n");
     printf("Charset panels:\033CSpace \033Bor\033CReturn \033Bselect");
     printf("\033B character  & move  back to grid panel.");
     printf("\033C Escape\033Bmoves to other charset panel.\n");
     printf("\n");
     printf("Commands:\033CI\033Binverts char.  \033CC\033Bclears the");
     printf("\033B grid.  \033CR\033Breverts to ROM copy of char.");
     printf("\033C X\033Band\033CY\033Bflip the character.   \033CH\033Band\033CV");
     printf("\033B roll the character. \033C<\033Bkey selects the");
     printf("\033B previous char.\033C>\033Bgoes to next char.\n");
     printf("\n");
     printf("Cut'n'paste: \033CU\033Bcopies  the character to");
     printf("\033B the paste buffer.  \033CP\033Bcopies the paste");
     printf("\033B buffer to the character.  \033CW\033Bswaps the");
     printf("\033B character and paste buffer.\n");
     printf("                                        ");
     printf("File:\033CS\033B saves  the   character  set(s).");
     printf("\033C L\033B loads character set(s).            ");
     printf("\n");
     printf("Press\033CA\033Gfor info about the program.\n");

     for(;!key(););

     lores0();
     cls();
     paper(0);
     ink(7);

     printf("\n\n\n");
     printf("\033J\033C        Morgul's Font Editor\n");
     printf("\033J\033C        Morgul's Font Editor\033H2.0a\n");
     printf("\n");

     printf("\033B      ` 1995 Alexios Chouchoulas\n");
     printf("\033B     (alexios@vennea.demon.co.uk)\n\n");

           /*    1234567890123456789012345678901234567890*/
     printf("\033F   Written in C (cc65) and Assembly,\n");
     printf("\033F     on a PC using Euphoric 0.6c,\n");
     printf("\033F          the ORIC emulator.\n\n");

     printf("      Check out the ORIC Project at\n");
     printf("    http://www.ensica.fr/LOCAL/ORIC/\n\n");

     printf("    Lots of thanks to Fabrice Frances\n");
     printf("    (frances@ensica.fr) for Euphoric!\n\n\n");

     printf("\033I\033E              H_@\\\\0X\\T\n");
     printf("\033I\033E               _7 \"_! K5\n");
     printf("\033I\033E               _  @?  Z%%\n");
     printf("\033I\033E              H_\\^_\\\\_]T\n");
     printf("\033I\033E               !\n");

     for(;!key(););

}
#else


unsigned char     shbit,c,panel=0,set=0;
char y=0,x=5;
unsigned int  edit=32, i, chr, z;
unsigned char     cut[8],tmp[8],fname[17];


extern void showchar(unsigned int ofs);

extern unsigned int infopane(unsigned int a);

extern void roll(unsigned int chr);


void
drawset(unsigned int set)
{
     if(!set){
          memc[48461]=0x53;
          memc[48462]=0x54;
          memc[48463]=0x44;
          memc[48466]=8;
     }else{
          memc[48461]=0x41;
          memc[48462]=0x4c;
          memc[48463]=0x54;
          memc[48466]=9;
     }
}


unsigned int
selectchr(unsigned int set, unsigned char edit, unsigned char highlight)
{
     unsigned int chr,adr,z;
     unsigned char *x;

     if(!set){
          chr=(unsigned)0xb400+(edit<<3);
          if(highlight){
               z=edit-32;
               adr=(unsigned)48131+(unsigned)(((z/16)&0xff)*40)
                    +(unsigned)(z&0xf);
               memc[adr]|=0x80;
          }
     } else {
          chr=(unsigned)0xb800+(edit<<3);
          if(highlight){
               z=edit-32;
               adr=(unsigned)48151+(unsigned)(((z/8)&0xff)*40)
                    +(unsigned)(z&0x7);
               memc[adr]|=0x80;
          }
     }
     drawset(set);
     showchar(chr);
     infopane(edit);
     return chr;
}


void
focus(unsigned int panel,unsigned int attr)
{
     switch(panel){
          case 0:
               memc[48080]=attr;
               memc[48120]=attr;
               memc[48160]=attr;
               memc[48200]=attr;
               memc[48240]=attr;
               memc[48280]=attr;
               memc[48320]=attr;
               memc[48360]=attr;
               memc[48400]=attr;
               memc[48440]=attr;
               return;
          case 1:
               memc[48090]=attr;
               memc[48130]=attr;
               memc[48170]=attr;
               memc[48210]=attr;
               memc[48250]=attr;
               memc[48290]=attr;
               memc[48330]=attr;
               memc[48370]=attr;
               return;
          case 2:
               memc[48110]=attr;
               memc[48150]=attr;
               memc[48190]=attr;
               memc[48230]=attr;
               memc[48270]=attr;
               memc[48310]=attr;
               memc[48350]=attr;
               memc[48390]=attr;
               memc[48430]=attr;
               memc[48470]=attr;
               return;
     }
}


void
gopanel(unsigned int cur,unsigned int new)
{
     focus(cur,20);
     focus(new,21);
}


void
unfocuschar(unsigned int edit)
{
     unsigned int z=edit-32;
     if(!set)memc[48131+((z/16)&0xff)*40+(z&0xf)]=edit&0x7f;
     else memc[48151+((z/8)&0xff)*40+(z&0x7)]=edit&0x7f;
}


void
help()
{
     memcpy(mainscreen,(char*)textvram,1120);
     dumpscreen(helpscreen);
     while(key());
     get();
     dumpscreen(mainscreen);
}


void
about()
{
     memcpy(mainscreen,(char*)textvram,1120);
     dumpscreen(aboutscreen);
     while(key());
     get();
     dumpscreen(mainscreen);
}


unsigned char saves1[7]="!SAVEO\"";
unsigned char saves2[16]="\",A#B400,E#B7FF";
unsigned char command[41];


void
sedsave(unsigned int s)
{
     unsigned int i=0,j;

     for(j=0;saves1[j];j++,i++)command[i]=saves1[j];
     for(j=0;fname[j];j++,i++)command[i]=fname[j];
     for(j=0;saves2[j];j++,i++)command[i]=saves2[j];
     command[i]=0;
     command[i-10]=((s==1)?'8':'4');
     command[i-3]=((!s)?'7':'B');
     command[i-2]=((!s)?'F':'7');
     printf("\n\nIssuing DOS command:\n%s",command);
     sedoric((char *)&command);
     printf("\n\n...Done. Press any key to return.");
     get();
     call(0x600);
}


unsigned int
getfname()
{
     unsigned char cp,c;

     for(fname[cp=0]=c=0;c!=13;){
          switch(c=get()){
               case 27:
                    return 0;
               case 127:
                    if(cp){
                         cp--;
                         printf("\010 \010");
                    }
                    break;
               case 20:
                    memc[0x20c]^=0x80;
                    break;
               case 13:
                    break;
               default:
                    if((isalpha(c)||isdigit(c))&&(cp<16)){
                         fname[cp]=c;
                         cp=cp+1;
                         putchar(c);
                    }
          }
     }
     fname[cp]=0;

     memc[0x20c]|=0x80;
     return 1;
}


void
print(unsigned char s)
{
     unsigned int a,e,i;

     switch(s){
     case 0:
          a=0xb400;
          e=0xb7ff;
          break;
     case 1:
          a=0xb800;
          e=0xbb7f;
          break;
     case 2:
          a=0xb400;
          e=0xbb7f;
          break;
     }

     printf("\n\nPlease wait...\n");

     call(0xc816);
     lprintf("%s\n",fname);
     for(i=a;i<=e;i++){
          switch(i&7){
               case 0:
                    lprintf("  BYTE %d, ",memc[i]);
                    break;
               case 7:
                    lprintf("%d  ; ASCII %d\n",memc[i],((i-s)/8)&0x7f);
                    break;
               default:
                    lprintf("%d, ",memc[i]);
          }
     }
     call(0xc82f);
}


void
save()
{
     unsigned char s, c, format;

     memcpy(mainscreen,(char*)textvram,1120);
     cls();
     paper(0);
     ink(7);
     printf("\n\n");
     printf("\033GSave: (Escape to cancel)\n\n");
     setflags(SCREEN|CURSOR|NOKEYCLICK);
               /*1234567890123456789012345678901234567890*/
     printf("\033B(S)tandard character set\n");
     printf("\033B(A)lternate character set\n");
     printf("\033B(B)oth character sets?\n\n");
     printf("\033BSave which set(s)?\033G");

     do{
          switch(c=toupper(get())){
               case 27: goto done;
               case 'S':
                    s=0; /* A#B400,E#B7FF */
                    break;
               case 'A':
                    s=1; /* A#B800,E#BB7F */
                    break;
               case 'B':
                    s=2; /* A#B400,E#BB7F */
                    break;
               default: continue;
          }
          break;
     }while(1);
     printf("%c\n",c);

     printf("\n\n");
     printf("\033B(1) Raw data (to disk)\n");
     printf("\033B(2) Assembly (to printer)\n");
     printf("\033BFormat?\033G");

     do{
          c=get();
          if(c==27)goto done;
          else if(c>='1' && c<='2')break;
          else continue;
     }while(1);
     putchar(c);
     format=c-'1';

     printf("\n\n");
     printf("\033BFilename?\033G");

     if(!getfname())goto done;

     if(!format){
          sedsave(s);
     } else print(s);

done:
     setflags(SCREEN|NOKEYCLICK);
     dumpscreen(mainscreen);
}


unsigned char loads[7]="!LOAD\"";


void
load()
{
     unsigned char s, c, format;
     unsigned int i,j;

     memcpy(mainscreen,(char*)textvram,1120);
     cls();
     paper(0);
     ink(7);

     for(;;){
          printf("\n\n");
          printf("\033G(Escape to cancel, Enter for DIR)\n\n");
          printf("\033GPlease enter filename: ");
          setflags(SCREEN|CURSOR|NOKEYCLICK);
          if(!getfname()){
               setflags(SCREEN|NOKEYCLICK);
               dumpscreen(mainscreen);
               return;
          }
          printf("\n");

          if(fname[0]==0){
               sedoric("!DIR");
               get();
               call(0x600);
          }
          else break;
     }

     setflags(SCREEN|NOKEYCLICK);
     dumpscreen(mainscreen);

     i=0;
     for(j=0;loads[j];j++,i++)command[i]=loads[j];
     for(j=0;fname[j];j++,i++)command[i]=fname[j];
     command[i]=0;
     sedoric((char *)&command);
     call(0x600);
}


void
handleglobals(unsigned char c)
{
     unsigned int y,x;

     switch(toupper(c)){
          case 'I':
               for(y=chr;y<chr+8;y++)memc[y]^=0xff;
               goto done;
          case 'C':
               for(y=chr;y<chr+8;y++)memc[y]=0;
               goto done;
          case 'R':
               if(!set){
                    for(y=0,edit-=32;y<8;y++){
                         memc[y+chr]=memc[0xfc78+y+(edit<<3)];
                    }
                    edit+=32;
               } else {
                    y=edit-32;
                    memc[chr]=memc[0xf861+(y&0x03)];
                    memc[chr+1]=memc[0xf861+(y&0x03)];
                    memc[chr+2]=memc[0xf861+(y&0x03)];
                    memc[chr+3]=memc[0xf861+((y/4)&0x03)];
                    memc[chr+4]=memc[0xf861+((y/4)&0x03)];
                    memc[chr+5]=memc[0xf861+((y/16)&0x03)];
                    memc[chr+6]=memc[0xf861+((y/16)&0x03)];
                    memc[chr+7]=memc[0xf861+((y/16)&0x03)];
               }
               goto done;
          case 'X':
               for(y=0;y<4;y++){
                    x=memc[chr+y];
                    memc[chr+y]=memc[chr+(7-y)];
                    memc[chr+(7-y)]=x;
               }
               goto done;
          case 'Y':
               for(y=chr;y<chr+8;y++){
                    x=(memc[y]&0x1)*32;
                    x|=(memc[y]&0x2)*8;
                    x|=(memc[y]&0x4)*2;
                    x|=(memc[y]&0x8)/2;
                    x|=(memc[y]&0x10)/8;
                    x|=(memc[y]&0x20)/32;
                    memc[y]=x;
               }
               goto done;
          case 'H':
               roll(chr);
               goto done;
          case 'V':
               x=memc[chr];
               for(y=chr;y<chr+7;y++)memc[y]=memc[y+1];
               memc[chr+7]=x;
               goto done;
          case 'U':
               memcpy((char *)cut,(char *)chr,8);
               goto done;
          case 'P':
               memcpy((char *)chr,(char *)cut,8);
               goto done;
          case 'W':
               memcpy((char *)tmp,(char *)chr,8);
               memcpy((char *)chr,(char *)cut,8);
               memcpy((char *)cut,(char *)tmp,8);
               goto done;
          case '>':
          case '.':
               unfocuschar(edit);
               edit++;
               if(!set)edit=edit%0x80;
               else edit=edit%0x60;
               if(edit<32)edit=32;
               chr=selectchr(set,edit,1);
               goto done;
          case '<':
          case ',':
               unfocuschar(edit);
               edit--;
               if(edit<32){
                    if(!set)edit=0x7f;
                    else edit=0x5f;
               }
               chr=selectchr(set,edit,1);
               goto done;
          case '?':
          case '/':
               help();
               return;
          case 'A':
               about();
               return;
          case 'S':
               save();
               return;
          case 'L':
               load();
               return;
     }
done:
     showchar(chr);
     return;
}


void
mainloop()
{
     chr=selectchr(set,edit,1);

     for(;;){
          switch(panel){
               case 0:
                    i=48046-x+(y+2)*40;
                    memc[i]|=0x80;
                    switch(c=get()){
                         case 3: goto quit;
                         case 9:
                              if((--x)<0)x=5;
                              break;
                         case 8:
                              if((++x)>5)x=0;
                              break;
                         case 10: if((++y)>7)y=0; break;
                         case 11: if((--y)<0)y=7; break;
                         case 32:
                              shbit=1<<x;
                              c=memc[chr+y];
                              if(c&shbit){
                                   memc[i]=0x80|'.';
                              } else {
                                   memc[i]=0xff;
                              }
                              memc[chr+y]=c^shbit;
                              break;
                         case 27:
                              gopanel(panel,set+1);
                              panel=set+1;
                              break;
                         default:
                              handleglobals(c);
                    }
                    memc[i]&=0x7f;
                    break;
               default:
                    z=(unsigned)(edit-32);
                    if(!set)i=(unsigned)48131+(unsigned)(((z/16)&0xff)*40)+
                         (unsigned)(z&0xf);
                    else i=(unsigned)48151+(unsigned)(((z/8)&0xff)*40)+
                         (unsigned)(z&0x7);
                    memc[i]=edit|0x80;
                    z=edit;
                    switch(c=get()){
                         case 3: goto quit;
                         case 8:
                              if((--edit)<32)edit=(set?0x5f:0x7f);
                              break;
                         case 9:
                              if((++edit)>(set?0x5f:0x7f))edit=32;
                              break;
                         case 10:
                              edit+=(set?8:16);
                              if(edit>(set?0x5f:0x7f))edit-=(set?64:96);
                              break;
                         case 11:
                              edit-=(set?8:16);
                              if(edit<32)edit+=(set?64:96);
                              break;
                         case 13:
                         case 32:
                              gopanel(panel,0);
                              panel=0;
                              chr=selectchr(set,edit,1);
                              break;
                         case 27:
                              if(!set){
                                   if(edit>0x5f)edit=0x5f;
                                   gopanel(panel,2);
                                   panel=2;
                              } else {
                                   gopanel(panel,1);
                                   panel=1;
                              }
                              set=!set;
                              chr=selectchr(set,edit,1);
                              break;
                         default:
                              handleglobals(c);
                    }
                    if(c!=13 && c!=32)memc[i]&=0x7f;
                    if(z!=edit)chr=selectchr(set,edit,0);
                    break;
/*               case 2:
                    if(edit>0x5f)edit=0x5f;
                    set=1;
                    z=edit-32;
                    i=48151+((z/8)&0xff)*40+(z&0x7);
                    memc[i]=edit|0x80;
                    z=edit;
                    switch(c=get()){
                         case 3: goto quit;
                         case 8:
                              if((--edit)<32)edit=0x5f;
                              break;
                         case 9:
                              if((++edit)>0x5f)edit=32;
                              break;
                         case 10:
                              edit+=8;
                              if(edit>0x5f)edit-=64;
                              break;
                         case 11:
                              edit-=8;
                              if(edit<32)edit+=64;
                              break;
                         case 13:
                         case 32:
                              gopanel(panel,0);
                              panel=0;
                              chr=selectchr(1,edit,1);
                              break;
                         case 27:
                              gopanel(panel,1);
                              panel=1;
                              chr=selectchr(0,edit,1);
                              break;
                         default:
                              handleglobals(c);
                    }
                    if(c!=13 && c!=32)memc[i]&=0x7f);
                    if(z!=edit)chr=selectchr(1,edit,0);
                    break; */
          }
     }

     quit:;
     gotoxy(10,10);
}

#endif

void
main()
{
     #ifdef MAKE
     makescreens();
     exit(0);
     #else

     setflags(SCREEN|NOKEYCLICK);
     dumpscreen(mainscreen);
     mainloop();
     #endif
 }
